#include "decoder.h"
#include <X11/Xft/Xft.h>
#include <gdk/gdkx.h>

G_DEFINE_TYPE (PangoFcDecoderTest, pango_fc_decoder_test, PANGO_TYPE_FC_DECODER)

static FcCharSet  *test_get_charset (FcPattern *pattern);
static PangoGlyph  test_get_glyph   (PangoFcFont *font,
				     FT_Face face,
				     guint32 wc);
static void        test_finalize    (GObject *object);

void
pango_fc_decoder_test_init (PangoFcDecoderTest *decoder)
{
}

void
pango_fc_decoder_test_class_init (PangoFcDecoderTestClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS(klass);
  PangoFcDecoderClass *parent_class = PANGO_FC_DECODER_CLASS (klass);

  object_class->finalize = test_finalize;

  parent_class->get_charset = test_get_charset;
  parent_class->get_glyph = test_get_glyph;
}

PangoFcDecoderTest *
pango_fc_decoder_test_new (void)
{
  return g_object_new (PANGO_TYPE_FC_DECODER_TEST, NULL);
}

FcCharSet *
test_get_charset (FcPattern *pattern)
{
  FcCharSet *retval = NULL;
  printf("get charset!\n");
  FcPatternGetCharSet (pattern, FC_CHARSET, 0, &retval);

  return retval;
}

PangoGlyph
test_get_glyph   (PangoFcFont *font,
		  FT_Face face,
		  guint32 wc)
{
  XftFont *xft_font;

  printf("get glyph! 0x%x\n", wc);

  xft_font = XftFontOpenPattern(GDK_DISPLAY(), FcPatternDuplicate(font->font_pattern));

  return XftCharIndex(NULL, xft_font, wc);
}

void
test_finalize (GObject *object)
{
  GObjectClass *parent_class = G_OBJECT_CLASS (pango_fc_decoder_test_parent_class);
  printf("test_finalize\n");
  parent_class->finalize(object);
}
